/* R-U-ON Agents plugin          */
/* Copyright (c) 2006 R-U-ON LLC */
/* www.r-u-on.com                */

var sevBitmaps = [];
sevBitmaps['Critical'] = graphics.loadImage("critical.gif");
sevBitmaps['Major'] = graphics.loadImage("major.gif");
sevBitmaps['Minor'] = graphics.loadImage("minor.gif");
sevBitmaps['Okay'] = graphics.loadImage("clear.gif");
clearBitmap = graphics.loadImage("clear.gif");

var sevColors = [];
sevColors['Critical'] = "#FFCF9C";
sevColors['Major'] = "#FFE7AD";
sevColors['Minor'] = "#FFFFAD";
sevColors['Okay'] = "#BBFDA8";

var agentsItems = [];

contentArea.contentFlags = gddContentFlagHaveDetails;

onTimer();    
setInterval(onTimer, 1000 * 60 * 10);  // Ten minutes

function agentDate(ad) {
    //ad = ad.replace(","," 2006,");
    return new Date(ad);
}

function snippet(agent, tm) {
    var html = '<html><head></head><body style="font-family:arial;font-size:8pt">';
    var color = sevColors[agent['severity']];
    var ignore = {"severity":true, "agent":true, "link":true };

    for (i in agent) {
        if (ignore[i]) {
            continue;
        }
        if (i=="Severity") {
            html+="Severity: ";
            html+='<span style="background-color:'+color+'">&nbsp;'+agent['severity']+"&nbsp;</span>";
        } else {
            html+=(i+": "+agent[i]);
        }
        html+="<br>";
    }

    html+="</body></html>";
    return html;
}

function noAgents() {

    var tm = new Date();
    tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
    
    var item = new ContentItem();
    item.heading = 'No agents installed';
    item.time_created = tm.getVarDate();
    item.layout = gddContentItemLayoutEmail;
    item.flags = gddContentItemFlagStatic;
    item.image = sevBitmaps['Minor'];
        
    contentArea.addContentItem(item, gddItemDisplayInSidebar);
}

function createStatus() {
    contentArea.removeAllContentItems();
    
    var statusItem = new ContentItem();
    statusItem.layout = gddContentItemLayoutNews;
    statusItem.onDetailsView = NoDetails;

    var tm = new Date();
    tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
    statusItem.time_created = tm.getVarDate();
    statusItem.flags = gddContentItemFlagStatic;
    
    contentArea.addContentItem(statusItem, gddItemDisplayInSidebar);
    
    for (var i=0;i<agentsItems.length;++i) {
        contentArea.addContentItem(agentsItems[i], gddItemDisplayInSidebar);
    }
    return statusItem;
}

function NoDetails(item) {
    return null;
}

function setStatus(s) {
    var statusItem = createStatus();
    statusItem.source = s;
}

function setError(s) {
   var statusItem = createStatus();
   statusItem.snippet = s;
    
   statusItem.onDrawItem = ErrDraw;         
   statusItem.onGetHeight = ErrHeight;   
}

function ErrHeight(item, target, graphics, width) {
    var h = graphics.GetTextHeight(item.snippet, width, gddTextFlagWordBreak, gddFontNormal);
    return h*2+2;
}

function ErrDraw(item, target, graphics, x, y, width, height) {
    graphics.DrawText(x, y+height/2-1, width, height, item.snippet, "#ff0000", gddTextFlagWordBreak, gddFontNormal);
}

function setInstruction(msg, instruction, url) {
    var statusItem = createStatus();
    statusItem.snippet = msg;
    statusItem.source = instruction;
    statusItem.open_command = url;
    statusItem.flags = gddContentItemFlagNoRemove;
    
    statusItem.onDrawItem = InstDraw;         
    statusItem.onGetHeight = InstHeight;   
}

function InstHeight(item, target, graphics, width) {
    var h = graphics.GetTextHeight(item.snippet, width, gddTextFlagWordBreak, gddFontNormal)+5;
    if (item.source!=null && item.source!='') {
        h+=graphics.GetTextHeight(item.source, width, gddTextFlagWordBreak, gddFontExtraInfo)+10;
    } 
    return h;
}

function InstDraw(item, target, graphics, x, y, width, height) {
 
    graphics.DrawText(x, y+5, width, height, item.snippet, gddColorNormalText, gddTextFlagWordBreak, gddFontNormal);
    if (item.source!=null && item.source!='') {
        var h = graphics.GetTextHeight(item.snippet, width, gddTextFlagWordBreak, gddFontNormal)+5;
        graphics.DrawText(x, h+10, width, height, item.source, gddColorExtraInfo, gddTextFlagWordBreak, gddFontExtraInfo);
    } 
}

function showAgents(agents) {

    contentArea.removeAllContentItems();
    agentsItems = [];
    
    if (agents.length==0) {
        noAgents();
        return;
    } 
    
    setStatus("Last update");

    for (var i = agents.length-1;i>=0;--i) {

        var tm = agentDate(agents[i]['Last contact']);

        var item = new ContentItem();
        item.heading = agents[i]['agent'];
        if (agents[i]["State"]!="ON") {
            item.heading+=(" ("+agents[i]["State"]+")");
        }
        item.source = agents[i]['Type']+'  -  '+agents[i]['IP'];
        item.snippet = snippet(agents[i], tm);
        item.open_command = agents[i]['link'];
        //item.tooltip = alarms[i]['description'];
        item.time_created = tm.getVarDate();
        item.flags = gddContentItemFlagPinned + gddContentItemFlagNoRemove + gddContentItemFlagShareable;
        item.layout = gddContentItemLayoutEmail;
        item.image = sevBitmaps[agents[i]['severity']];
        
        item.onDrawItem = DrawItem;         
        item.onGetHeight = GetItemHeight;   
        item.onDetailsView = onDetailsView;

        contentArea.addContentItem(item, gddItemDisplayInSidebar);
        agentsItems[agentsItems.length] = item;
    }
}

function onDetailsView(item) {
    var control = new DetailsView();
    var tm = new Date(''+item.time_created);
    tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
    control.SetContent(item.source.split('  -  ')[0], tm.getVarDate(), item.snippet, false, item.layout);
    control.html_content = true;

    var details = new Object();
    details.details_control = control;
  
    return details;
}

function GetItemHeight(item, target, graphics, width) {
    return 2 + 2*graphics.GetTextHeight(item.heading, width, 0, gddFontNormal)+3;
}

function DrawItem(item, target, graphics, x, y, width, height) {
 
    graphics.DrawText(x, y, width-40, height/2, item.heading, gddColorNormalText, 0, gddFontNormal);
    graphics.DrawImage(width-40, y, 40, 14, item.image, 100);


    var rsrc = item.source.split("  -  ");
    var slack = 2;
    var w1 = graphics.GetTextWidth(rsrc[0], 0, gddFontExtraInfo);
    var w2 = graphics.GetTextWidth(rsrc[1], 0, gddFontExtraInfo);

    if (width-w1-slack<w2) {
        // ...
        var w3 = graphics.GetTextWidth("...", 0, gddFontExtraInfo);
        graphics.DrawText(x+w1+slack, y+height/2+1, w3, height/2, "...", gddColorSnippet, 0, gddFontExtraInfo);
        graphics.DrawText(x+w1+slack+w3, y+height/2+1, width-w1-slack-w3, height/2, rsrc[1], gddColorSnippet, gddTextFlagRight, gddFontExtraInfo);
    } else {
        graphics.DrawText(x+w1+slack, y+height/2+1, width-w1-slack, height/2, rsrc[1], gddColorSnippet, gddTextFlagRight, gddFontExtraInfo);
    }

    graphics.DrawText(x, y+height/2+1, width, height/2, rsrc[0], gddColorSnippet, 0, gddFontExtraInfo);
}

function parseAgent(node) {
    var agent = new Array();
    var title = node.getElementsByTagName("title")[0].firstChild.nodeValue;
    var link = node.getElementsByTagName("link")[0].firstChild.nodeValue;
    var cdata = node.getElementsByTagName("description")[0].firstChild.nodeValue;

    var idx = title.lastIndexOf(": ");
    agent['agent'] = title;
    agent['Agent'] = title;
    agent['link'] = link;

    var cp = cdata.split("<br>");
    for (var i=0;i<cp.length;++i) {
        var nv = cp[i].split(": ");
        agent[nv[0]] = nv[1];
    }
    agent['severity'] = agent['Severity'];
    return agent;
}

function parseAgents(text) {
    try {   
        var doc = new DOMDocument();
        doc.loadXML(text);
        
        var rss = doc.getElementsByTagName("rss")[0];
        var channel = doc.getElementsByTagName("channel")[0];
        var items = doc.getElementsByTagName("item");

        if (items.length==1) {
            var title = items[0].getElementsByTagName("title")[0].firstChild.nodeValue;
            if (title=="R-U-ON Feed Exception") {
                var cdata = items[0].getElementsByTagName("description")[0].firstChild.nodeValue;
                setError("R-U-ON returned an error: \r\n"+cdata);
                return null;
            }
        }

        
        var agents = [];
        for (var i=0;i<items.length;++i) {
            agents[i] = parseAgent(items[i]);
        }

        return agents;
    } catch(e) {
        setError(e.message+"\r\n\r\n(Internal Error)");
        return null;
    }
}

function onTimer()
{
    var guid = options("guid");

    if (guid==null || guid=="") {
        setInstruction("Go to the Options window to enter account information.",
                       "Double click to create an account.",
                       "http://www.r-u-on.com/ctrl?action=newaccount");
        return;
    }
    
    setStatus("Loading...");

    var url = "http://rss.r-u-on.com/rssagents?ggadget&id=" + guid;
    
    var req = new XMLHttpRequest();
    req.onreadystatechange = agents;
    req.open("GET", url, true);
    req.send();

    function agents() {
        if (req.readyState == 4) {
            if (req.status == 200) {
                var agents = parseAgents(req.responseText);
                if (agents!=null) {
                    try {
                        showAgents(agents);
                    } catch (e) {
                        alert(e);
                    }
                }
            } else if (req.status==500) {
                if (req.responseText.indexOf("no such account")>0) {
                    setError("Account id invalid - try to login again (Options window)");
                } else {
                    setError("Server encountered an internal error - Please try again later (Refresh)");
                }
            } else {
                setError("Service/Network unavailable");
            }
        }
    }
}


